"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("../../injector");

var _create = require("../../codec/create");

var _RuntimeVersion = _interopRequireDefault(require("../../json/RuntimeVersion.002.json"));

// Copyright 2017-2019 @polkadot/types authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
describe('RuntimeVersion', () => {
  let version;
  beforeEach(() => {
    version = (0, _create.createType)('RuntimeVersion', _RuntimeVersion.default.result);
  });
  it('has the correct authoring', () => {
    expect(version.authoringVersion.toNumber()).toEqual(10);
  });
  it('has the apis', () => {
    const [apiId, apiVersion] = version.apis[0];
    expect(apiId.toHex()).toEqual('0xdf6acb689907609b');
    expect(apiVersion.toNumber()).toEqual(2);
  });
  it('has the correct implementation', () => {
    expect(version.implName.toString()).toEqual('substrate-node');
    expect(version.implVersion.toNumber()).toEqual(60);
  });
  it('has the correct spec', () => {
    expect(version.specName.toString()).toEqual('node');
    expect(version.specVersion.toNumber()).toEqual(60);
  });
});